package nc.ui.gl.multibooksdef;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import nc.bs.logging.Log;
import nc.ui.bd.BDGLOrgBookAccessor;
import nc.ui.gl.multibooksdef.ChartModel;
import nc.ui.gl.multibooksdef.ChartUi;
import nc.ui.gl.multibooksdef.GlOrgBookListToListDialog;
import nc.ui.glpub.IPara;
import nc.ui.glpub.IParent;
import nc.ui.glpub.IUiPanel;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ButtonObject;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.ToftPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIDialogEvent;
import nc.ui.pub.beans.UIDialogListener;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.gl.multibooks.MultiFormatVO;
import nc.vo.ml.NCLangRes4VoTransl;

public class ChartView extends ToftPanel implements IPara, IUiPanel, UIDialogListener {

   private ChartModel m_ChartModel = null;
   public IParent m_parent;
   private ButtonObject[] m_arryCurrentButtons = new ButtonObject[5];
   private ButtonObject m_addButton = new ButtonObject(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000406"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000406"), 2, "增加");
   private ButtonObject m_delButton = new ButtonObject(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000391"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000391"), 2, "删除");
   private ButtonObject m_modButton = new ButtonObject(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000407"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000407"), 2, "修改");
   private ButtonObject m_refreshButton = new ButtonObject(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000180"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000180"), 2, "刷新");
   private ButtonObject m_copyButton = new ButtonObject(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000408"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000408"), 2, "复制到其他主体账簿");
   IUiPanel m_cardView;
   private ChartUi ivjChartUi = null;
   private GlOrgBookListToListDialog glOrgBookListToListDialog = null;


   public ChartView() {
      this.initialize();
   }

   public void addListener(Object objListener, Object objUserdata) {
   }

   public String[] getAllDataItemExpress() {
      return new String[]{"subjcode", "subjname", "dispname", "subjtype", "balanorient", "subjlev", "sealflag", "unit", "asstype"};
   }

   public String[] getAllDataItemNames() {
      return null;
   }

   public ButtonObject[] getButtons() {
      this.m_arryCurrentButtons[0] = this.m_addButton;
      this.m_arryCurrentButtons[1] = this.m_modButton;
      this.m_arryCurrentButtons[2] = this.m_delButton;
      this.m_arryCurrentButtons[3] = this.m_refreshButton;
      this.m_arryCurrentButtons[4] = this.m_copyButton;
      return this.m_arryCurrentButtons;
   }

   private ChartModel getChartModel() {
      if(this.m_ChartModel == null) {
         this.m_ChartModel = new ChartModel(this);
         this.m_ChartModel.addPropertyChangeListener(this.getChartUi());
      }

      return this.m_ChartModel;
   }

   private ChartUi getChartUi() {
      if(this.ivjChartUi == null) {
         try {
            this.ivjChartUi = new ChartUi();
            this.ivjChartUi.setName("ChartUi");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjChartUi;
   }

   public ClientEnvironment getClientEnvironment() {
      return super.getClientEnvironment();
   }

   public String getTitle() {
      return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000409");
   }

   private void handleException(Throwable exception) {
      Log.getInstance(this.getClass()).info("--------- 未捕捉到的异常 ---------");
      exception.printStackTrace(System.out);
   }

   private void initialize() {
      try {
         this.setName("MainPanel");
         this.setLayout(new BorderLayout());
         this.setSize(774, 419);
         this.add(this.getChartUi(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.getChartUi().setChartModel(this.getChartModel());
      this.getGlOrgBookListToListDialog().addUIDialogListener(this);
      this.refresh();
   }

   public Object invoke(Object objData, Object objUserData) {
      return null;
   }

   public boolean isNumber(String itemExpress) {
      return false;
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         ChartView aChartView = new ChartView();
         exception.setContentPane(aChartView);
         exception.setSize(aChartView.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.ToftPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void nextClosed() {
      Log.getInstance(this.getClass()).info("Next Closed,What I can do for it?");
   }

   public void onButtonClicked(ButtonObject bo) {
      try {
         if(bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000407"))) {
            if(this.getChartModel().getSize() == 0) {
               return;
            }

            if(this.getChartModel().getCurrentIndex() < 0) {
               this.getChartModel().setCurrentIndex(0);
            }

            this.showNext();
            this.m_cardView.invoke(this.getChartModel().getCurrent(), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000407"));
         } else if(bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000410"))) {
            this.showNext();
            this.m_cardView.invoke(this.getChartModel().getCurrent(), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000410"));
         } else if(bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000406"))) {
            this.showNext();
            this.m_cardView.invoke((Object)null, NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000406"));
         } else if(bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000391"))) {
            if(this.verifyDelete()) {
               this.getChartModel().delCurrent();
            }
         } else if(bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000180"))) {
            this.refresh();
         } else if(!bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000181")) && bo.getName().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000408"))) {
            if(this.getChartModel().getSize() == 0) {
               return;
            }

            this.getGlOrgBookListToListDialog().showModal();
         }
      } catch (Exception var3) {
         Log.getInstance(this.getClass()).error(var3);
         this.showErrorMessage(var3.getMessage());
      }

   }

   public void refresh() {
      try {
         this.getChartModel().removeAll();
         this.getChartModel().QueryAll();
         this.getGlOrgBookListToListDialog().refreshBesidesTheGlorgbook(((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getPrimaryKey(), "2002305005");
      } catch (Throwable var2) {
         Log.getInstance(this.getClass()).error(var2);
      }

   }

   public void removeListener(Object objListener, Object objUserdata) {
   }

   public void showMe(IParent p_parent) {
      p_parent.getUiManager().removeAll();
      p_parent.getUiManager().add(this, this.getName());
      if(p_parent instanceof ToftPanel) {
         ToftPanel new_name = (ToftPanel)p_parent;
         String orgbookname = ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getGlorgbookname();
         new_name.updateStatusBarAccountMsg(orgbookname);
      }

      this.m_parent = p_parent;
   }

   private IUiPanel showNext() {
      if(this.m_cardView == null) {
         this.m_cardView = (IUiPanel)this.m_parent.showNext("nc.ui.gl.multibooksdef.DetailDefineUI");
      } else {
         this.m_parent.showNext(this.m_cardView);
      }

      this.m_cardView.addListener(this.getChartModel(), (Object)null);
      return this.m_cardView;
   }

   private boolean verifyDelete() {
      if(this.getChartModel().getSize() == 0) {
         return false;
      } else if(this.getChartUi().getMultiColList().getTable().getSelectedRow() < 0) {
         MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000642"));
         return false;
      } else {
         int iResult = this.showYesNoMessage(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000411") + ((MultiFormatVO)this.getChartModel().getCurrent()).getMulticolName() + NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000412"));
         return iResult == 4;
      }
   }

   public void dialogClosed(UIDialogEvent event) {
      if(event.getSource() == this.glOrgBookListToListDialog) {
         if(event.m_Operation == 202) {
            return;
         }

         if(event.m_Operation == 204) {
            String[][] rst = (String[][])null;
            String[] pk_glorgbooks = null;

            try {
               pk_glorgbooks = this.glOrgBookListToListDialog.getSelectedGlorgbooks();
               rst = this.getChartModel().copyCurrent(pk_glorgbooks);
            } catch (Exception var6) {
               ;
            }

            StringBuffer msg = new StringBuffer();

            for(int i = 0; i < rst.length; ++i) {
               if(rst[i] != null && rst[i].length != 0) {
                  msg.append(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000413") + BDGLOrgBookAccessor.getGlOrgBookVOByPrimaryKey(pk_glorgbooks[i]).getGlorgbookname() + NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000415"));
               } else {
                  msg.append(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000413") + BDGLOrgBookAccessor.getGlOrgBookVOByPrimaryKey(pk_glorgbooks[i]).getGlorgbookname() + NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000414"));
               }
            }

            MessageDialog.showHintDlg(this, NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000298"), msg.toString());
         }
      }

   }

   private GlOrgBookListToListDialog getGlOrgBookListToListDialog() {
      if(this.glOrgBookListToListDialog == null) {
         this.glOrgBookListToListDialog = new GlOrgBookListToListDialog(this);
      }

      return this.glOrgBookListToListDialog;
   }
}
